from matplotlib import pyplot as plt
from matplotlib import patches, collections
import numpy as np


def plot_polygon(pol, color=(0,1,0)):
    vertices = np.array(list(map(lambda vertex: [vertex.x, vertex.y], pol)), dtype=float)

    a = plt.subplot()
    p = patches.Polygon(vertices, True, color=color)

    a.add_patch(p)

def plot_segments(segments, colors=(0, 1, 0)):
    segs = np.array(segments, dtype=float)

    a = plt.subplot()

    p = collections.LineCollection(segs, colors=colors)

    a.add_collection(p)


def show_all():
    plt.show()
