import unittest
from .polygon import Polygon
from .boolean import *

vertices = [
    (1, 1),
    (2, -2),
    (4, 1),
    (8, 1),
    (4, 4),
    (8, 8),
    (1, 6)
]
vertices2 = [
    (1, 1),
    (5, 1),
    (5, 5),
    (1, 5)
]

polygon = Polygon(vertices)
polygon2 = Polygon(vertices2)

class TestPolygonInclusion(unittest.TestCase):
    def test_outside_bb(self):
        self.assertEqual(0, polygon.point_in_polygon((9, 5)))

    def test_outside(self):
        self.assertEqual(0, polygon.point_in_polygon((5, 4)))

    def test_inside(self):
        self.assertEqual(2, polygon.point_in_polygon((2, 2)))

    def test_border(self):
        self.assertEqual(1, polygon.point_in_polygon((1, 4)))

    def test_vertex(self):
        self.assertEqual(1, polygon.point_in_polygon((4, 1)))

    def test_special(self):
        self.assertEqual(2, polygon.point_in_polygon((3, 3)))

    def test_special2(self):
        self.assertEqual(2, polygon.point_in_polygon((2, -1)))

    def test_bottomleft(self):
        self.assertEqual(0, polygon.point_in_polygon(polygon.bottomLeft))

def test_boolean():
    a = polygon_intersection(polygon, polygon2)
    b = polygon_reconstruction(a)
    print(b)
    return b
